'use strict';

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Required for self-signed the ssl issue
process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

var authorise = function authorise(route) {
  return function (_ref) {
    var email = _ref.email,
        password = _ref.password;
    return (0, _axios2.default)({
      url: route,
      method: 'post',
      data: {
        email: email,
        passwd: password
      }
    }).then(function (result) {
      return result.data;
    });
  };
};

var requestData = function requestData(url) {
  var method = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'get';
  return function (auth) {
    return (0, _axios2.default)({
      url: url,
      method: method,
      headers: {
        'x-auth': auth
      }
    }).then(function (result) {
      return result.data;
    });
  };
};

module.exports = function (routes) {
  return {
    authorise: authorise(routes.authorise),
    sentiment: requestData(routes.sentiment),
    cabinet: requestData(routes.cabinet),
    commentary: requestData(routes.commentary),
    vitals: requestData(routes.vitals),
    exchanges: requestData(routes.exchanges),
    majors: requestData(routes.majors),
    marketcap: requestData(routes.marketcap),
    rankings: requestData(routes.rankings),
    insight: requestData(routes.insight),
    portfolios: requestData(routes.portfolios, 'post'),
    coins: requestData(routes.coins, 'post')
  };
};